/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "baseclass.h"

using namespace std;

static string derivtype[] = {
	"",
	"public",
	"protected",
	"private"
};

void
BaseClass::output(ostream &stream)
{
  if (deriv_type != NONE)
    stream << derivtype[deriv_type] << " ";

  if (is_virtual)
    stream << " virtual ";

  stream << getClassName();
}

const string
BaseClass::derivToString() const
{
  if (deriv_type > NONE && deriv_type < DUMMY_TYPE)
    return derivtype[deriv_type];

  return "";
}

