/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef BRANCHANALYSER_H
#define BRANCHANALYSER_H

#include "programanalyser.h"

class MultiMethodTypes;

/**
Checks for conflicting return types in branches of a multimethod

        @author Lorenzo Bettini <http://www.lorenzobettini.it>
 */
class BranchAnalyser : public ProgramAnalyser
{
 protected:
  MultiMethodTypes &multi_method_types;

 public:
  BranchAnalyser(SourceStructs *src, MultiMethodTypes &mt) :
    ProgramAnalyser (src), multi_method_types (mt) {}

  virtual ~BranchAnalyser() {}

  virtual int analyse_multimethod(const MultiMethod *);
};

#endif // BRANCHANALYSER_H
