/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef BRANCHTYPE_H
#define BRANCHTYPE_H

#include "methodstruct.h"
#include "tostringrep.h"
#include "withtokeninfo.h"

class DeclType;
class MethParams;
class ClassDecl;
class MethParam;

/**
@author Lorenzo Bettini
*/
class BranchType : public ToStringRep, public WithTokenInfo, public MethodStruct
{
public:
  BranchType(const string &name,
             const ClassDecl *receiver, const MethParam *target,
             DeclType *ret, const MethParams *p, AccessType at,
             const WithTokenInfo &wti);

  ~BranchType();

  const ClassDecl *getReceiverType() const { return getClassDecl(); }
  const ClassDecl *getParamType() const;
  const MethParam *getParam() const;
  const DeclType *getRetType() const { return getDeclType(); }

  bool equals(const BranchType &b) const;
  bool equalsReceiver(const BranchType &b) const;

  bool isSubType(const BranchType &b, bool equal_ok = true, bool ok_private = false) const;

  bool operator<(const BranchType &b) const
  { return (method_name+toString())<(b.method_name+b.toString()); }
};

#endif
