/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef CLASSEND_H
#define CLASSEND_H

#include "progelem.h"

class ClassDecl;

// doublecpp: forward declarations, DO NOT MODIFY
class ProgElems; // file: progelems.h
class SourceModifier; // file: sourcemodifier.h
// doublecpp: end, DO NOT MODIFY

class ClassEnd : public ProgElem
{
 protected:
  ClassDecl *class_decl; // this end belongs to class_decl

 public:
  ClassEnd() : ProgElem ("};") {}

  ClassDecl *getClassDecl() const { return class_decl; }
  void setClassDecl(ClassDecl *c);
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_intern_add_item(ProgElems *);
virtual void dispatch_transform_elem(SourceModifier *, ProgElems * modified_decl, ProgElems * modified_meth);
// doublecpp: end, DO NOT MODIFY
};

#endif // CLASSEND_H

