/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <iostream>
#include <stdlib.h>

#include "errormanager.h"
#include "withtokeninfo.h"
#include "mainglobalvars.h"

using namespace std;

void
ErrorManager::print(const string &err, const WithTokenInfo *t)
{
  print(err, *t);
}

void
ErrorManager::print(const string &err, const WithTokenInfo &t)
{
  print(err, t.getFileName(), t.getLine());
}

void
ErrorManager::print(const string &err, const string &file, const int line)
{
  cerr << file;

  if (line > 0)
    cerr << ":" << line;

  cerr << ": " << err << endl;
}

void
ErrorManager::print(const string &err)
{
  cerr << input_file;

  cerr << ": " << err << endl;
}

void
ErrorManager::warning(const string &err, const WithTokenInfo *t)
{
  print ("warning: " + err, t);
}

void
ErrorManager::exit_failure()
{
  if (! test_mode)
    exit (EXIT_FAILURE);

  exit (EXIT_SUCCESS);
}
