/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef INCLUDEHEADER_H
#define INCLUDEHEADER_H

#include "progelem.h"

// doublecpp: forward declarations, DO NOT MODIFY
class ProgElems; // file: progelems.h
class SourceModifier; // file: sourcemodifier.h
// doublecpp: end, DO NOT MODIFY

class IncludeHeader : public ProgElem
{
 protected:
  bool system_include;
  string filename;

 public:
  IncludeHeader(const string &f);

  const string &getFileName() const { return filename; }
  bool isSystemInclude() const { return system_include; }
  void changeFileName(const string &);
  virtual const string toString() const;
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_intern_add_item(ProgElems *);
virtual void dispatch_transform_elem(SourceModifier *, ProgElems * modified_decl, ProgElems * modified_meth);
// doublecpp: end, DO NOT MODIFY
};

#endif // INCLUDEHEADER_H
