/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef INCLUDEHEADERS_H
#define INCLUDEHEADERS_H

#include "includeheader.h"

#include <list>
#include <set>
#include <string>

using std::list;
using std::set;
using std::string;

class IncludeHeaders : public list<IncludeHeader *>
{
 protected:
  set<string> set_of_headers;

 public:
  void add(IncludeHeader *i)
  {
    push_back (i);
    set_of_headers.insert (i->getFileName());
  }

  bool contains_header(const string &h) const
  {
    return (set_of_headers.find (h) != set_of_headers.end ());
  }
  
  void change_header(const string &old, const string &new_name);
};

typedef IncludeHeaders::const_iterator IncludeHeaderIterator;


#endif // INCLUDEHEADERS_H
