/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef INCLUDEMODIFIER_H
#define INCLUDEMODIFIER_H

#include <string>
#include <map>
#include <list>

using std::string;
using std::map;
using std::list;

class SourceStructs;
class ProgElems;

class IncludingFiles : public map<string, list<const ProgElems *> >
{
};

class IncludeModifier {
protected:
    SourceStructs *orig_sources;
    SourceStructs *modified_decls;
    IncludingFiles including_files;
    
    void modify_source(ProgElems *, const string &, const string &);
    void update_including_files(const ProgElems *);
public:
    IncludeModifier(SourceStructs *orig, SourceStructs *md) :
	orig_sources (orig), modified_decls (md)
    {}
    virtual ~IncludeModifier() {}
    
    virtual void modify_prog();
};

#endif // INCLUDEMODIFIER_H
