/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef INHERITEDTYPEGENERATOR_H
#define INHERITEDTYPEGENERATOR_H

#include <multitypemodifier.h>
#include "accesstype.h"

class ClassDecl;
class BranchType;

/**
expand the multi type by making all the inherited methods explicit

@author Lorenzo Bettini
*/
class InheritedTypeGenerator : public MultiTypeModifier
{
protected:
  MultiMethodTypes &inherited_types;
  bool error;

public:
  InheritedTypeGenerator(const MultiMethodTypes& t, MultiMethodTypes &inh);

  virtual void generate_type(const string& meth, const MultiMethodType& t);
  void generate_type(const string& meth, const BranchType &btype, const ClassDecl *class_to_inspect);
  bool found_error() const { return error; }
};

#endif
