/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <assert.h>

#include "methdecl.h"
#include "mainglobalvars.h"
#include "methparams.h"
#include "methodbody.h"

MethDecl::MethDecl(DeclType *ret_type, const MethParams *pars, MethodBody *b, AccessType at) :
  MethodStruct(ret_type, pars, at), body (b), specialized (true), is_copy (false)
{
}

MethDecl::MethDecl(const MethDecl &m) :
  ProgElem (m), MethodStruct (m), body (m.body), specialized (m.specialized), is_copy (true)
{
}

MethDecl::~MethDecl()
{
    if (is_copy)
      return;

    if (params)
      delete params;

    if (body)
      delete body;
}

const string
MethDecl::toString() const
{
  return decl_type->toString () + " " + getMethodName () + "(" +
         (params ? params->toStringNoName () : "") + ")";
}

