/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef METHDECL_H
#define METHDECL_H

#include "progelem.h"
#include "methodstruct.h"

class MethodBody;

class MethDecl : public ProgElem, public MethodStruct
{
 protected:
  MethodBody *body;
  bool specialized;
  bool is_copy; // whether this method is a copy of another one
  // (in this case we do not delete its fields)

 public:
  MethDecl(DeclType *ret_type, const MethParams *pars, MethodBody *b, AccessType at);
  MethDecl(const MethDecl &m);

  virtual ~MethDecl();

  const MethodBody *getBody() const { return body; }
  bool isSpecialized() const { return specialized; }
  bool isRedefined() const { return ! isSpecialized (); }
  void setSpecialized(bool b) { specialized = b; }

  virtual const string toString() const;
};

#endif // METHDECL_H

