/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef METHODBODY_H
#define METHODBODY_H

#include <list>

#include "normaltext.h"

using std::list;

typedef NormalText MethodInstruction;
typedef list<MethodInstruction *> MethodInstructions;
typedef MethodInstructions::const_iterator InstructionIterator;

class MethodBody : public WithTokenInfo
{
 protected:
  MethodInstructions instructions;

 public:
  MethodBody() {}
  virtual ~MethodBody();

  const MethodInstructions *getInstructions() const { return &instructions; }
  void addInstruction(MethodInstruction *);
};

#endif // METHODBODY_H

