/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "methods.h"
#include "mainerrormanager.h"

bool
Methods::addMethod(MethDecl *m)
{
  if (methods.find (m) != methods.end ())
    return false;

  push_back (m);
  methods.insert (m);

  return true;
}

const MethDecl *
Methods::getMethod(const MethDecl *m) const
{
  MethodSet::const_iterator mit = methods.find (m);

  if (mit == methods.end())
    return 0;

  return *mit;
}
