/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef METHODS_H
#define METHODS_H

#include <list>

#include "methodset.h"

using std::list;

class Methods : public list<MethDecl *>
{
 protected:
  MethodSet methods;

 public:
  ~Methods()
  {
    for (const_iterator it = begin (); it != end (); ++it)
      {
        delete *it;
      }
  }

  bool find(const MethDecl *m) const
  {
    return (methods.find (m) != methods.end());
  }

  const MethDecl *getMethod(const MethDecl *m) const;

  bool addMethod(MethDecl *m);
};

typedef Methods::const_iterator MethodsIterator;

#endif // METHODS_H

