/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "methparam.h"

MethParam::MethParam(const string &name, DeclType *t) :
  ProgElem (name), WithDeclType (t)
{
}

const string
MethParam::toString() const
{
  return (getDeclType()->toString () + " " + getText());
}

const string
MethParam::toStringNoName() const
{
  return (getDeclType()->toString ());
}

// only change the main type name, but keep other feature of
// the type
const string
MethParam::toString(const string &new_name) const
{
  return (getDeclType()->toString (new_name) + " " + getText());
}
