/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef METHPARAM_H
#define METHPARAM_H

#include "progelem.h"
#include "withdecltype.h"

class MethParam : public ProgElem, public WithDeclType
{
 public:
  MethParam(const string &name, DeclType *t);

  bool equals(const MethParam *p) const
  {
    return (p && getText () == p->getText () &&
            getDeclType()->equals(p->getDeclType()) );
  }

  bool equalsNoName(const MethParam *p) const
  {
    return (p && getDeclType()->equals(p->getDeclType()) );
  }

  virtual const string toString() const;
  const string toString(const string &) const;
  const string toStringNoName() const;
};

#endif // METHPARAM_H

