/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <assert.h>

#include "multimethods.h"
#include "methdecl.h"

MultiMethod *
MultiMethods::retrieveMultiMethod(const string &s) const
{
    MultiMethod b(s);

    // TODO: this creates a temporary only for searching...
    // find a better way?
    const_iterator it = find (&b);

    if (it != end ())
      return *it;

    return 0;
}

bool
MultiMethods::hasMethod(const MethDecl *m) const
{
  MultiMethod *b = retrieveMultiMethod (m->getMethodName());

  return (b && b->hasMethod (m));
}

const MethDecl *
MultiMethods::getMethod(const MethDecl *m) const
{
  MultiMethod *b = retrieveMultiMethod (m->getMethodName());

  if (! b)
    return 0;

  return b->getMethod(m);
}

void
MultiMethods::addMethod(MethDecl *m)
{
  MultiMethod *b = retrieveMultiMethod (m->getMethodName());

  assert (b);

  b->add_method (m);
}
