/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MULTIMETHDOS_H
#define MULTIMETHDOS_H

#include <set>

#include "multimethod.h"

using std::set;

struct MultiMethod_less
{
  typedef std::less<string> value_compare;

  value_compare value_comp;

  bool operator() (const MultiMethod *i1, const MultiMethod *i2) const
  { return (value_comp (i1->getMethodName (), i2->getMethodName ())); }
};

class MultiMethods : public set<MultiMethod *, MultiMethod_less>
{
 public:
  MultiMethod *retrieveMultiMethod(const string &s) const;
  bool hasMethod(const MethDecl *) const;
  const MethDecl *getMethod(const MethDecl *m) const;
  void addMethod(MethDecl *);
};

typedef MultiMethods::const_iterator MultiMethodsIterator;

#endif // MULTIMETHDOS_H

