/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef MULTIMETHODTYPE_H
#define MULTIMETHODTYPE_H

#include <set>

using std::set;

#include "branchtype.h"

/**
represent a set of branch types associated to the same method

@author Lorenzo Bettini
*/
class MultiMethodType : protected set<BranchType>
{
private:
  typedef set<BranchType> BaseType;

public:
  typedef const_iterator BranchTypeIterator;
  using BaseType::begin;
  using BaseType::end;
  using BaseType::size;

  MultiMethodType();

  ~MultiMethodType();

  void addBranchType(const BranchType &);
  const string toString() const;
};

typedef MultiMethodType::BranchTypeIterator MultiMethodTypeIterator;

#endif
