/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef MULTITYPEMODIFIER_H
#define MULTITYPEMODIFIER_H

#include <string>

using std::string;

class MultiMethodTypes;
class MultiMethodType;

/**
base class for classes that have to act and modify multi method types

@author Lorenzo Bettini
*/
class MultiTypeModifier
{
protected:
  const MultiMethodTypes &multi_method_types;

public:
  MultiTypeModifier(const MultiMethodTypes &t);
  virtual ~MultiTypeModifier() {}

  void generate();

protected:
  virtual void generate_type(const string &meth, const MultiMethodType &t) = 0;
};

#endif
