/***************************************************************************
 *   Copyright (C) 2003-2006 by Lorenzo Bettini                            *
 *   http://www.lorenzobettini.it                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef PARAMBINDER_H
#define PARAMBINDER_H

#include "programanalyser.h"

/**
Binds the class of the specializing parameter of each multimethod

	@author Lorenzo Bettini <http://www.lorenzobettini.it>
*/
class ParamBinder : public ProgramAnalyser
{
  public:
  ParamBinder(SourceStructs *src) :
    ProgramAnalyser (src) {}

  virtual ~ParamBinder() {}

  /**
   * It will bind the class declaration in parameters and return type of
   * the specified MethDecl
   * @param  methdecl The specific branch
   * @return failure or success
   */
  virtual int analyse_method(const MethDecl *methdecl);
};

#endif
