/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NORMAL_T = 258,
     NEWLINE_T = 259,
     IDE_T = 260,
     INCLUDEFILE_T = 261,
     PUBLIC_T = 262,
     PRIVATE_T = 263,
     PROTECTED_T = 264,
     VIRTUAL_T = 265,
     SINGLECOMMENT_T = 266,
     END_BRANCH = 267,
     CONST_T = 268,
     BEGIN_METHOD = 269,
     CLASS_END = 270,
     INCLUDE_T = 271,
     BEGIN_FORWARD_DECL = 272,
     END_TAG = 273,
     BEGIN_PREVIOUS_BRANCH = 274,
     BEGIN_DISPATCH = 275,
     END_METHOD = 276,
     BRANCH_T = 277,
     CLASS_T = 278
   };
#endif
/* Tokens.  */
#define NORMAL_T 258
#define NEWLINE_T 259
#define IDE_T 260
#define INCLUDEFILE_T 261
#define PUBLIC_T 262
#define PRIVATE_T 263
#define PROTECTED_T 264
#define VIRTUAL_T 265
#define SINGLECOMMENT_T 266
#define END_BRANCH 267
#define CONST_T 268
#define BEGIN_METHOD 269
#define CLASS_END 270
#define INCLUDE_T 271
#define BEGIN_FORWARD_DECL 272
#define END_TAG 273
#define BEGIN_PREVIOUS_BRANCH 274
#define BEGIN_DISPATCH 275
#define END_METHOD 276
#define BRANCH_T 277
#define CLASS_T 278




/* Copy the first part of user declarations.  */
#line 1 "parser.yy"

/*
 * Copyright (C) 2003 Lorenzo Bettini <http://www.lorenzobettini.it>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>

#include <string.h>

#include "yyerror.h"
#include "progelems.hpp"
#include "normaltext.h"
#include "mainprogelems.h"
#include "classdecl.h"
#include "multimethod.h"
#include "methodbody.h"
#include "classend.h"
#include "forwarddecls.h"
#include "virtmultimethod.h"
#include "dispatchmeths.h"
#include "includeheader.h"
#include "accesstype.h"
#include "methparams.h"

#define YYERROR_VERBOSE

int line = 0 ;
AccessType current_access_type;

extern int yylex() ;
extern FILE *yyin ;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 50 "parser.yy"
{
  int tok ; /* command */
  char * ide_string ; /* ide_string : id, ... */
  struct multimethodinfo {
    bool is_virtual; // whether the multimethod is virtual
    char *previous; // possible text before multimethod
  } multimethodinfo ;
  bool boolean;

  class NormalText *normaltext;
  class ProgElem *progelem;
  class ClassDecl *classdecl;
  class BaseClass *baseclass;
  BaseClasses *baseclasses;
  DerivedType derivedtype;
  class DeclType *decl_type;
  class MultiMethod *multimethod;
  class MethDecl *methdecl;
  class MethParam *methparam;
  class MethParams *methparams;
  class MethodBody *methodbody;
  MethodInstruction *methinstr;
  class ClassEnd *classend;
  class ForwardDecl *forwarddecl;
  class ForwardDecls *forwarddecls;
  class IncludeHeader *includeheader;
  class VirtMultiMethod *virtualmultimethod;
  class DispatchMeths *dispatchmeths;
  class Methods *methods;
}
/* Line 187 of yacc.c.  */
#line 222 "parser.cc"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 247 "parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  32
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   93

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  31
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  30
/* YYNRULES -- Number of rules.  */
#define YYNRULES  61
/* YYNRULES -- Number of states.  */
#define YYNSTATES  92

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   278

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      28,    29,    30,     2,    27,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    26,    25,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    24,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    29,    31,    33,    35,    39,    40,    43,
      45,    49,    55,    58,    62,    66,    67,    70,    71,    75,
      77,    81,    85,    86,    88,    89,    91,    93,    95,   100,
     103,   105,   113,   120,   123,   125,   132,   140,   141,   145,
     147,   150,   151,   153,   157,   158,   160,   161,   163,   166,
     168,   170
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      32,     0,    -1,    33,    -1,    32,    33,    -1,    34,    -1,
      35,    -1,    48,    -1,    36,    -1,    37,    -1,    41,    -1,
      42,    -1,    40,    -1,    23,     5,    43,    24,    -1,     3,
      -1,     4,    -1,    15,    -1,    17,    38,    18,    -1,    -1,
      38,    39,    -1,    39,    -1,    23,     5,    25,    -1,    23,
       5,    25,    11,     5,    -1,    16,     6,    -1,    19,    51,
      18,    -1,    20,    51,    18,    -1,    -1,    26,    44,    -1,
      -1,    44,    27,    45,    -1,    45,    -1,    47,    46,     5,
      -1,    10,    47,     5,    -1,    -1,    10,    -1,    -1,     7,
      -1,     8,    -1,     9,    -1,    22,     5,    49,    12,    -1,
      49,    50,    -1,    50,    -1,    46,    56,    28,    53,    29,
      14,    59,    -1,    46,    56,    28,    53,    29,    25,    -1,
      51,    52,    -1,    52,    -1,    56,     5,    28,    53,    29,
      25,    -1,    56,     5,    28,    53,    29,    14,    59,    -1,
      -1,    53,    27,    54,    -1,    54,    -1,    56,    55,    -1,
      -1,     5,    -1,    57,     5,    58,    -1,    -1,    13,    -1,
      -1,    30,    -1,    59,    60,    -1,    60,    -1,    35,    -1,
      21,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   115,   115,   120,   127,   128,   129,   130,   131,   132,
     133,   134,   137,   145,   146,   149,   152,   156,   157,   162,
     169,   174,   180,   185,   189,   193,   194,   197,   198,   203,
     210,   215,   222,   223,   226,   227,   228,   229,   232,   249,
     254,   261,   269,   278,   283,   290,   295,   303,   304,   309,
     316,   323,   324,   327,   334,   335,   338,   339,   342,   347,
     354,   355
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NORMAL_T", "NEWLINE_T", "IDE_T",
  "INCLUDEFILE_T", "PUBLIC_T", "PRIVATE_T", "PROTECTED_T", "VIRTUAL_T",
  "SINGLECOMMENT_T", "END_BRANCH", "CONST_T", "BEGIN_METHOD", "CLASS_END",
  "INCLUDE_T", "BEGIN_FORWARD_DECL", "END_TAG", "BEGIN_PREVIOUS_BRANCH",
  "BEGIN_DISPATCH", "END_METHOD", "BRANCH_T", "CLASS_T", "'{'", "';'",
  "':'", "','", "'('", "')'", "'*'", "$accept", "text", "possibletext",
  "classdecl", "normaltext", "classend", "forwarddecls", "forwardclasses",
  "forwarddecl", "includeheader", "virtualmultimethod", "dispatchmeths",
  "inheritfrom", "baseclasses", "baseclass", "isvirtual", "derivedtype",
  "branchdecl", "multimethod", "branchmeth", "methods", "method",
  "paramlist", "param", "paramname", "decl_type", "isconst", "ispointer",
  "methbody", "methinstr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   123,    59,    58,    44,    40,    41,
      42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    31,    32,    32,    33,    33,    33,    33,    33,    33,
      33,    33,    34,    35,    35,    36,    37,    38,    38,    38,
      39,    39,    40,    41,    42,    43,    43,    44,    44,    44,
      45,    45,    46,    46,    47,    47,    47,    47,    48,    49,
      49,    50,    50,    51,    51,    52,    52,    53,    53,    53,
      54,    55,    55,    56,    57,    57,    58,    58,    59,    59,
      60,    60
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     1,     1,     3,     0,     2,     1,
       3,     5,     2,     3,     3,     0,     2,     0,     3,     1,
       3,     3,     0,     1,     0,     1,     1,     1,     4,     2,
       1,     7,     6,     2,     1,     6,     7,     0,     3,     1,
       2,     0,     1,     3,     0,     1,     0,     1,     2,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    13,    14,    15,     0,    17,    54,    54,     0,     0,
       0,     2,     4,     5,     7,     8,    11,     9,    10,     6,
      22,     0,     0,    19,    55,    54,    44,     0,     0,    54,
      32,    25,     1,     3,     0,    16,    18,    23,    43,     0,
      56,    24,    33,    54,    32,    40,    27,     0,    20,    47,
      57,    53,     0,    38,    39,    35,    36,    37,    34,    26,
      29,    32,    12,     0,     0,    49,    51,    47,     0,    34,
       0,    21,    54,     0,    52,    50,     0,    31,    28,    30,
      48,     0,    45,     0,    61,    60,    46,    59,     0,    42,
      58,    41
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    10,    11,    12,    85,    14,    15,    22,    23,    16,
      17,    18,    47,    59,    60,    43,    61,    19,    44,    45,
      25,    26,    64,    65,    75,    27,    28,    51,    86,    87
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -48
static const yytype_int8 yypact[] =
{
      32,   -48,   -48,   -48,    39,    30,    51,    51,    60,    61,
      11,   -48,   -48,   -48,   -48,   -48,   -48,   -48,   -48,   -48,
     -48,    62,     2,   -48,   -48,     4,   -48,    63,    64,    19,
      65,    44,   -48,   -48,    46,   -48,   -48,   -48,   -48,    45,
      42,   -48,   -48,    51,    50,   -48,    33,    52,    66,    -1,
     -48,   -48,    53,   -48,   -48,   -48,   -48,   -48,     1,    47,
     -48,    65,   -48,    73,    -6,   -48,    74,    -1,    75,    49,
      77,   -48,    51,    -9,   -48,   -48,    34,   -48,   -48,   -48,
     -48,    -2,   -48,    -7,   -48,   -48,    -2,   -48,    -2,   -48,
     -48,    -2
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -48,   -48,    76,   -48,     3,   -48,   -48,   -48,    67,   -48,
     -48,   -48,   -48,   -48,    14,    23,    27,   -48,   -48,    43,
      81,    21,    24,    18,   -48,   -43,   -48,   -48,     5,   -47
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -55
static const yytype_int8 yytable[] =
{
      52,     1,     2,    13,   -54,    81,    66,    88,    55,    56,
      57,    32,    24,    13,     1,     2,    82,    24,    89,    84,
      35,    72,    37,    73,    66,    21,     3,     4,     5,    66,
       6,     7,    24,     8,     9,     1,     2,    41,   -34,    90,
      55,    56,    57,    58,    90,    20,    38,     3,     4,     5,
      38,     6,     7,    21,     8,     9,    55,    56,    57,    58,
      42,    72,    53,    83,    24,    30,    31,    34,    39,    40,
      46,    48,    50,    49,    69,    42,    62,    63,    71,    74,
      77,    67,    79,    78,    70,    68,    33,    54,    29,    36,
      80,    76,     0,    91
};

static const yytype_int8 yycheck[] =
{
      43,     3,     4,     0,     5,    14,    49,    14,     7,     8,
       9,     0,    13,    10,     3,     4,    25,    13,    25,    21,
      18,    27,    18,    29,    67,    23,    15,    16,    17,    72,
      19,    20,    13,    22,    23,     3,     4,    18,     5,    86,
       7,     8,     9,    10,    91,     6,    25,    15,    16,    17,
      29,    19,    20,    23,    22,    23,     7,     8,     9,    10,
      10,    27,    12,    29,    13,     5,     5,     5,     5,     5,
      26,    25,    30,    28,    27,    10,    24,    11,     5,     5,
       5,    28,     5,    69,    61,    58,    10,    44,     7,    22,
      72,    67,    -1,    88
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    15,    16,    17,    19,    20,    22,    23,
      32,    33,    34,    35,    36,    37,    40,    41,    42,    48,
       6,    23,    38,    39,    13,    51,    52,    56,    57,    51,
       5,     5,     0,    33,     5,    18,    39,    18,    52,     5,
       5,    18,    10,    46,    49,    50,    26,    43,    25,    28,
      30,    58,    56,    12,    50,     7,     8,     9,    10,    44,
      45,    47,    24,    11,    53,    54,    56,    28,    47,    27,
      46,     5,    27,    29,     5,    55,    53,     5,    45,     5,
      54,    14,    25,    29,    21,    35,    59,    60,    14,    25,
      60,    59
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 116 "parser.yy"
    {
               //printf("%s", $1);
        prog_elems->add_item ((yyvsp[(1) - (1)].progelem));
       }
    break;

  case 3:
#line 121 "parser.yy"
    {
        //printf("%s", $2);
        prog_elems->add_item ((yyvsp[(2) - (2)].progelem));
       }
    break;

  case 4:
#line 127 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].classdecl); }
    break;

  case 5:
#line 128 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].normaltext); }
    break;

  case 6:
#line 129 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].multimethod); }
    break;

  case 7:
#line 130 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].classend); }
    break;

  case 8:
#line 131 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].forwarddecls); }
    break;

  case 9:
#line 132 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].virtualmultimethod); }
    break;

  case 10:
#line 133 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].dispatchmeths); }
    break;

  case 11:
#line 134 "parser.yy"
    { (yyval.progelem) = (yyvsp[(1) - (1)].includeheader); }
    break;

  case 12:
#line 138 "parser.yy"
    {
            (yyval.classdecl) = new ClassDecl ((yyvsp[(2) - (4)].ide_string), (yyvsp[(3) - (4)].baseclasses));
            (yyval.classdecl)->setInfo ((yylsp[(1) - (4)]).first_line);
            (yyval.classdecl)->setStruct(!(yyvsp[(1) - (4)].boolean));
          }
    break;

  case 13:
#line 145 "parser.yy"
    { (yyval.normaltext) = new NormalText ((yyvsp[(1) - (1)].ide_string)); }
    break;

  case 14:
#line 146 "parser.yy"
    { (yyval.normaltext) = new NormalText ((yyvsp[(1) - (1)].ide_string)); }
    break;

  case 15:
#line 149 "parser.yy"
    { (yyval.classend) = new ClassEnd; }
    break;

  case 16:
#line 153 "parser.yy"
    { (yyval.forwarddecls) = (yyvsp[(2) - (3)].forwarddecls); }
    break;

  case 17:
#line 156 "parser.yy"
    { (yyval.forwarddecls) = 0; }
    break;

  case 18:
#line 158 "parser.yy"
    {
                 (yyvsp[(1) - (2)].forwarddecls)->push_back ((yyvsp[(2) - (2)].forwarddecl));
                 (yyval.forwarddecls) = (yyvsp[(1) - (2)].forwarddecls);
               }
    break;

  case 19:
#line 163 "parser.yy"
    {
                 (yyval.forwarddecls) = new ForwardDecls;
                 (yyval.forwarddecls)->push_back ((yyvsp[(1) - (1)].forwarddecl));
               }
    break;

  case 20:
#line 170 "parser.yy"
    {
               (yyval.forwarddecl) = new ForwardDecl ((yyvsp[(2) - (3)].ide_string));
             }
    break;

  case 21:
#line 175 "parser.yy"
    {
               (yyval.forwarddecl) = new ForwardDecl ((yyvsp[(2) - (5)].ide_string), (yyvsp[(5) - (5)].ide_string));
             }
    break;

  case 22:
#line 181 "parser.yy"
    {
                  (yyval.includeheader) = new IncludeHeader ((yyvsp[(2) - (2)].ide_string));
                }
    break;

  case 23:
#line 186 "parser.yy"
    { (yyval.virtualmultimethod) = new VirtMultiMethod ((yyvsp[(2) - (3)].methods)); }
    break;

  case 24:
#line 190 "parser.yy"
    { (yyval.dispatchmeths) = new DispatchMeths ((yyvsp[(2) - (3)].methods)); }
    break;

  case 25:
#line 193 "parser.yy"
    { (yyval.baseclasses) = 0; }
    break;

  case 26:
#line 194 "parser.yy"
    { (yyval.baseclasses) = (yyvsp[(2) - (2)].baseclasses); }
    break;

  case 27:
#line 197 "parser.yy"
    { (yyval.baseclasses) = 0; }
    break;

  case 28:
#line 199 "parser.yy"
    {
              (yyvsp[(1) - (3)].baseclasses)->push_back ((yyvsp[(3) - (3)].baseclass));
              (yyval.baseclasses) = (yyvsp[(1) - (3)].baseclasses);
            }
    break;

  case 29:
#line 204 "parser.yy"
    {
              (yyval.baseclasses) = new BaseClasses;
              (yyval.baseclasses)->push_back ((yyvsp[(1) - (1)].baseclass));
            }
    break;

  case 30:
#line 211 "parser.yy"
    {
           (yyval.baseclass) = new BaseClass ((yyvsp[(3) - (3)].ide_string), (yyvsp[(2) - (3)].boolean), (yyvsp[(1) - (3)].derivedtype));
           (yyval.baseclass)->setInfo ((yylsp[(3) - (3)]).first_line);
         }
    break;

  case 31:
#line 216 "parser.yy"
    {
           (yyval.baseclass) = new BaseClass ((yyvsp[(3) - (3)].ide_string), true, (yyvsp[(2) - (3)].derivedtype));
           (yyval.baseclass)->setInfo ((yylsp[(3) - (3)]).first_line);
         }
    break;

  case 32:
#line 222 "parser.yy"
    { (yyval.boolean) = false; }
    break;

  case 33:
#line 223 "parser.yy"
    { (yyval.boolean) = true; }
    break;

  case 34:
#line 226 "parser.yy"
    { (yyval.derivedtype) = NONE; }
    break;

  case 35:
#line 227 "parser.yy"
    { (yyval.derivedtype) = PUBLIC_TYPE; }
    break;

  case 36:
#line 228 "parser.yy"
    { (yyval.derivedtype) = PRIVATE_TYPE; }
    break;

  case 37:
#line 229 "parser.yy"
    { (yyval.derivedtype) = PROTECTED_TYPE; }
    break;

  case 38:
#line 233 "parser.yy"
    {
                // first check whether there was text in the same lin
                // before multimethod declaration
                if ((yyvsp[(1) - (4)].multimethodinfo).previous && (strlen((yyvsp[(1) - (4)].multimethodinfo).previous) > 0)) {
                  prog_elems->add_item (new NormalText((yyvsp[(1) - (4)].multimethodinfo).previous));
                }
          
                (yyval.multimethod) = (yyvsp[(3) - (4)].multimethod);
                (yyval.multimethod)->setInfo ((yylsp[(1) - (4)]).first_line, (yylsp[(4) - (4)]).first_line - 1);
                // subtract 1 because of the \n added after the generated comment
                if ((yyvsp[(1) - (4)].multimethodinfo).is_virtual)
                  (yyval.multimethod)->setVirtual(true);
                (yyval.multimethod)->updateMethodsName ((yyvsp[(2) - (4)].ide_string));
          }
    break;

  case 39:
#line 250 "parser.yy"
    {
          (yyvsp[(1) - (2)].multimethod)->add_method ((yyvsp[(2) - (2)].methdecl));
          (yyval.multimethod) = (yyvsp[(1) - (2)].multimethod);
        }
    break;

  case 40:
#line 255 "parser.yy"
    {
          (yyval.multimethod) = new MultiMethod;
          (yyval.multimethod)->add_method ((yyvsp[(1) - (1)].methdecl));
        }
    break;

  case 41:
#line 262 "parser.yy"
    {
            (yyval.methdecl) = new MethDecl((yyvsp[(2) - (7)].decl_type), (yyvsp[(4) - (7)].methparams), (yyvsp[(7) - (7)].methodbody), current_access_type);
            (yyval.methdecl)->setInfo ((yylsp[(3) - (7)]).first_line);
            if ((yyvsp[(1) - (7)].boolean))
              (yyval.methdecl)->setVirtual(true);
            (yyvsp[(7) - (7)].methodbody)->setInfo ((yylsp[(6) - (7)]).first_line);
          }
    break;

  case 42:
#line 270 "parser.yy"
    {
            (yyval.methdecl) = new MethDecl((yyvsp[(2) - (6)].decl_type), (yyvsp[(4) - (6)].methparams), 0, current_access_type);
            (yyval.methdecl)->setInfo ((yylsp[(3) - (6)]).first_line);
            if ((yyvsp[(1) - (6)].boolean))
              (yyval.methdecl)->setVirtual(true);
          }
    break;

  case 43:
#line 279 "parser.yy"
    {
          if ((yyvsp[(2) - (2)].methdecl)) (yyvsp[(1) - (2)].methods)->push_back ((yyvsp[(2) - (2)].methdecl));
          (yyval.methods) = (yyvsp[(1) - (2)].methods);
        }
    break;

  case 44:
#line 284 "parser.yy"
    {
          (yyval.methods) = new Methods;
          if ((yyvsp[(1) - (1)].methdecl)) (yyval.methods)->push_back ((yyvsp[(1) - (1)].methdecl));
        }
    break;

  case 45:
#line 291 "parser.yy"
    {
            (yyval.methdecl) = new MethDecl((yyvsp[(1) - (6)].decl_type), (yyvsp[(4) - (6)].methparams), 0, current_access_type);
            (yyval.methdecl)->setMethodName ((yyvsp[(2) - (6)].ide_string));
          }
    break;

  case 46:
#line 296 "parser.yy"
    {
            // simply discard it: it is a previously generated
            // _forward_ method for private and protected multimethods
            (yyval.methdecl) = 0;
          }
    break;

  case 47:
#line 303 "parser.yy"
    { (yyval.methparams) = 0; }
    break;

  case 48:
#line 305 "parser.yy"
    {
              (yyvsp[(1) - (3)].methparams)->addParam ((yyvsp[(3) - (3)].methparam));
              (yyval.methparams) = (yyvsp[(1) - (3)].methparams);
            }
    break;

  case 49:
#line 310 "parser.yy"
    {
              (yyval.methparams) = new MethParams;
              (yyval.methparams)->addParam ((yyvsp[(1) - (1)].methparam));
            }
    break;

  case 50:
#line 317 "parser.yy"
    {
        (yyval.methparam) = new MethParam ((yyvsp[(2) - (2)].ide_string), (yyvsp[(1) - (2)].decl_type));
        (yyval.methparam)->setInfo ((yylsp[(1) - (2)]).first_line);
      }
    break;

  case 51:
#line 323 "parser.yy"
    { (yyval.ide_string) = strdup (""); }
    break;

  case 52:
#line 324 "parser.yy"
    { (yyval.ide_string) = (yyvsp[(1) - (1)].ide_string); }
    break;

  case 53:
#line 328 "parser.yy"
    {
            (yyval.decl_type) = new DeclType ((yyvsp[(2) - (3)].ide_string), (yyvsp[(1) - (3)].boolean), (yyvsp[(3) - (3)].boolean));
            (yyval.decl_type)->setInfo ((yylsp[(2) - (3)]).first_line);
          }
    break;

  case 54:
#line 334 "parser.yy"
    { (yyval.boolean) = false; }
    break;

  case 55:
#line 335 "parser.yy"
    { (yyval.boolean) = true; }
    break;

  case 56:
#line 338 "parser.yy"
    { (yyval.boolean) = false; }
    break;

  case 57:
#line 339 "parser.yy"
    { (yyval.boolean) = true; }
    break;

  case 58:
#line 343 "parser.yy"
    {
            (yyvsp[(1) - (2)].methodbody)->addInstruction ((yyvsp[(2) - (2)].methinstr));
            (yyval.methodbody) = (yyvsp[(1) - (2)].methodbody);
          }
    break;

  case 59:
#line 348 "parser.yy"
    {
            (yyval.methodbody) = new MethodBody ();
            (yyval.methodbody)->addInstruction ((yyvsp[(1) - (1)].methinstr));
          }
    break;

  case 60:
#line 354 "parser.yy"
    { (yyval.methinstr) = (yyvsp[(1) - (1)].normaltext); }
    break;

  case 61:
#line 355 "parser.yy"
    { (yyval.methinstr) = new MethodInstruction ((yyvsp[(1) - (1)].ide_string)); }
    break;


/* Line 1267 of yacc.c.  */
#line 1950 "parser.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 358 "parser.yy"



