/*
 * Copyright (C) 2003 Lorenzo Bettini <http://www.lorenzobettini.it>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "progelem.h"

ProgElem::ProgElem(const string &s) :
  text (s)
{
}

ProgElem::ProgElem(const ProgElem &p) :
  WithTokenInfo (p), text (p.text)
{
}

void
ProgElem::output(ostream &stream)
{
  stream << text;
}

bool
ProgElem::isToBePreProcessed () const
{
  return true;
}

ostream &
operator<<(ostream &stream, const ProgElem &item)
{
  stream << item.toString ();
  return stream;
}

const string
ProgElem::toString() const
{
  return getText ();
}

