/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef SOURCEGENERATOR_H
#define SOURCEGENERATOR_H

#include <string>

using std::string;

class SourceStructs;
class ProgElems;

class SourceGenerator
{
 protected:
  const SourceStructs *sources;
  const SourceStructs *modified_declarations;
  const SourceStructs *modified_sources;

  virtual void generate_sources(const SourceStructs *);
  virtual void generate_sources(const ProgElems *);

 public:
  SourceGenerator(const SourceStructs *src, const SourceStructs *mod,
                  const SourceStructs *mod_s) :
   sources (src), modified_declarations (mod), modified_sources (mod_s) {}
  virtual ~SourceGenerator() {}

  virtual void generate();
};

#endif // SOURCEGENERATOR_H
