/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef SOURCEMODIFIERDOUBLE_H
#define SOURCEMODIFIERDOUBLE_H

#include "sourcemodifier.hpp"

class SourceModifierDouble : public SourceModifier
{
 protected:
  virtual void transform_classend(ClassEnd *, ProgElems *,
                                  ProgElems *);
  virtual void handle_restricted_methods(ProgElems *, const string &meth, const ClassDecl *cl);
  virtual void fill_target_forward_decls(const ClassDecl *, GeneratedForwardDecls &);

  virtual void generate_main_method(ProgElems *modified_meth,
                                    const BranchType &bt);

 public:
  SourceModifierDouble(SourceStructs *s, SourceStructs *src, SourceStructs *m,
                       const MultiMethodTypes &mtypes,
                       const MultiMethodTypes &db_types,
                       const MultiMethodTypes &ext) :
          SourceModifier (s, src, m, mtypes, db_types, ext) {}
};

#endif // SOURCEMODIFIERDOUBLE_H
