/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef SOURCEMODIFIERMODULAR_H
#define SOURCEMODIFIERMODULAR_H

#include "sourcemodifier.hpp"

class ClassHierarchy;

class SourceModifierModular : public SourceModifier
{
 protected:
  virtual void transform_classend(ClassEnd *, ProgElems *,
                                  ProgElems *);
  virtual void generate_main_method(ProgElems *modified_meth,
                                    const BranchType &bt);
  virtual bool should_invade_target(const string &) { return false; }
  virtual bool should_use_output_extension(const string &);
  virtual void fill_target_forward_decls(const ClassDecl *, GeneratedForwardDecls &) {}

  void gather_methods(ClassHierarchy &hier, const BranchType &bt);

 public:
  SourceModifierModular(SourceStructs *s, SourceStructs *src, SourceStructs *m,
                       const MultiMethodTypes &mtypes,
                       const MultiMethodTypes &db_types,
                       const MultiMethodTypes &ext) :
          SourceModifier (s, src, m, mtypes, db_types, ext) {
          visit_only_targets = false;
        }
};

#endif // SOURCEMODIFIERMODULAR_H
