/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "toptypegenerator.h"

#include "multimethodtypes.h"

TopTypeGenerator::TopTypeGenerator(const MultiMethodTypes &mtypes, MultiMethodTypes &ttypes)
  : MultiTypeModifier (mtypes), top_types (ttypes)
{
}

void
TopTypeGenerator::generate_type(const string &meth, const MultiMethodType &t)
{
  MultiMethodTypeIterator top;

  for (MultiMethodTypeIterator external = t.begin(); external != t.end(); ++external)
    {
      top = external;

      for (MultiMethodTypeIterator internal = t.begin(); internal != t.end(); ++internal)
        {
          if (! top->equalsReceiver(*internal))
            continue;

          if (top->isSubType(*internal))
            top = internal;
        }

      top_types.addType(*top);
    }
}
