/***************************************************************************
 *   Copyright (C) 2004 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef TOSTRINGREP_H
#define TOSTRINGREP_H

#include <string>
#include <iostream>

using std::string;
using std::ostream;

/**
base class for classes that provide a string representation

@author Lorenzo Bettini
*/
class ToStringRep
{
private:
  string rep;
public:
  ToStringRep(const string &s) : rep(s) {}

  virtual ~ToStringRep() {}

  const string &toString() const { return rep; }
};

ostream &
operator<<(ostream &stream, const ToStringRep &item);

ostream &
operator<<(ostream &stream, const ToStringRep *item);

#endif
