/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef VERBOSE_H
#define VERBOSE_H

#include <string>
#include <iostream>

using std::string;
using std::cerr;
using std::endl;

class Verbose
{
 protected:
  int verbosity;
  string indent;

 public:
  Verbose(int v = 0) : verbosity (v) {}

  void print(const string &s)
  {
    if (verbosity)
      cerr << indent << s << endl;
  }

  void print_noln(const string &s)
  {
    if (verbosity)
      cerr << s;
  }

  void inc_indent()
  {
    if (verbosity)
        indent += " ";
  }

  void dec_indent()
  {
    if (verbosity)
        indent = indent.substr(0, indent.size()-1);
  }
};

#endif // VERBOSE_H

