/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef WITHMETHDECLS_H
#define WITHMETHDECLS_H

#include "progelem.h"
#include "methods.h"

// doublecpp: forward declarations, DO NOT MODIFY
class ProgElems; // file: progelems.h
// doublecpp: end, DO NOT MODIFY

class WithMethDecls : public ProgElem
{
 protected:
  Methods *methods;

 public:
  WithMethDecls(Methods *m) : methods (m) {}
  ~WithMethDecls() { if (methods) delete methods; }

  void addMethod(MethDecl *m) { methods->push_back (m); }
  const Methods *getMethods() const { return methods; }
// doublecpp: dispatch methods, DO NOT MODIFY
public:
virtual void dispatch_intern_add_item(ProgElems *);
// doublecpp: end, DO NOT MODIFY
};

#endif // WITHMETHDECLS_H
