/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef WITHTOKENINFO_H
#define WITHTOKENINFO_H

// the basic structure that contains information about token position
// in the source file (e.g., the line number).

#include <string>

using std::string;

#include "mainglobalvars.h"

class WithTokenInfo
{
 protected:
  string source;
  int first_line;
  int last_line;

 public:
  WithTokenInfo() : first_line (-1), last_line(-1) {}
  WithTokenInfo(const WithTokenInfo &t) : source (t.source), first_line (t.first_line), last_line(t.last_line) {}

  int getLine() const { return first_line; }
  int getLastLine() const { return last_line; }
  const string &getFileName() const { return source; }
  void setInfo(int l, int ll = -1)
  {
    source = input_file;
    first_line = l;
    last_line = ll;
  }
};

#endif // WITHTOKENINFO_H
